% ************************************************************
% proceedureCode 2
% ************************************************************
    global EXPERIMENT;
    global SUBJECT;
    global BACKCOLOR;
    global EXPWIN;
    global current_folder;
    global DEVELOPMENT;
    global winWidth;
    global winHeight;
 
    current_folder = pwd;
    DEVELOPMENT = 1;
    SUBJECT = 0;
    
    InitializePsychSound;   % Perform basic initialization of the sound driver:
    ExpControl('StartExp'); % Set up screen for display  
    
    % ************************************************************
    % Open a file to record each trial conditions
    % ************************************************************
    
    condFile = fopen([EXPERIMENT '_' int2str(SUBJECT) '.txt'],'w');
    fprintf(condFile,'%s\n',datestr(now));
    fprintf(condFile,'Experiment %s\n',EXPERIMENT);
    fprintf(condFile,'subject %6s \n', int2str(SUBJECT));
    
    % ************************************************************
    % Picture Loading
    % ************************************************************
    
    m=imread([current_folder '/Images/car.jpg']);  % Read in the image
    car = Screen('MakeTexture',EXPWIN,m);     % Convert it to a texture
 
    m=imread([current_folder '/Images/cow.jpg']);  
    cow = Screen('MakeTexture',EXPWIN,m);     
    
    m=imread([current_folder '/Images/dog.jpg']);  
    dog = Screen('MakeTexture',EXPWIN,m);     
    
    m=imread([current_folder '/Images/sheep.jpg']);  
    sheep = Screen('MakeTexture',EXPWIN,m);     
    
    m=imread([current_folder '/Images/telephone.jpg']);  
    telephone = Screen('MakeTexture',EXPWIN,m);     
    
    m=imread([current_folder '/Images/train.jpg']); 
    train = Screen('MakeTexture',EXPWIN,m);     
    
    StimPic = [car cow dog sheep telephone train];
    
    % ************************************************************
    % Sound Loading
    % ************************************************************
    
    SOUNDFILE1 = ([current_folder '/Sounds/car_sound.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    carSHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', carSHandle, wavedataAG);
    
    SOUNDFILE1 = ([current_folder '/Sounds/car_word.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    carWHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', carWHandle, wavedataAG);
    
    SOUNDFILE1 = ([current_folder '/Sounds/cow_sound.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    cowSHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', cowSHandle, wavedataAG);
 
    
    SOUNDFILE1 = ([current_folder '/Sounds/cow_word.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    cowWHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', cowWHandle, wavedataAG);  

    SOUNDFILE1 = ([current_folder '/Sounds/train_word.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    trainWHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', trainWHandle, wavedataAG);
    
  
    SOUNDFILE1 = ([current_folder '/Sounds/dog_sound.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    dogSHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', dogSHandle, wavedataAG);
    
    
    SOUNDFILE1 = ([current_folder '/Sounds/dog_word.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    dogWHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', dogWHandle, wavedataAG);
    
    
    SOUNDFILE1 = ([current_folder '/Sounds/sheep_sound.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    sheepSHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', sheepSHandle, wavedataAG);
    
    SOUNDFILE1 = ([current_folder '/Sounds/sheep_word.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    sheepWHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', sheepWHandle, wavedataAG);
    
    
    SOUNDFILE1 = ([current_folder '/Sounds/telephone_sound.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    telephoneSHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', telephoneSHandle, wavedataAG);
    
    SOUNDFILE1 = ([current_folder '/Sounds/telephone_word.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    telephoneWHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', telephoneWHandle, wavedataAG);
    
    SOUNDFILE1 = ([current_folder '/Sounds/train_sound.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    trainSHandle = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', trainSHandle, wavedataAG);
    
    SOUNDFILE1 = ([current_folder '/Sounds/buzz.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    buzz = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', buzz, wavedataAG);
    
    SOUNDFILE1 = ([current_folder '/Sounds/bleep.wav']);
    wavfilenameAG = SOUNDFILE1;     
    [y, freqAG] = audioread(wavfilenameAG);
    wavedataAG = y';
    nrchannelsAG = size(wavedataAG,1);
    if nrchannelsAG < 2
        wavedataAG = [wavedataAG ; wavedataAG];
        nrchannelsAG = 2;
    end
    bleep = PsychPortAudio('Open', [], [], 0, freqAG, nrchannelsAG);
    PsychPortAudio('FillBuffer', bleep, wavedataAG);
    
    Audio = [carSHandle  cowSHandle  dogSHandle sheepSHandle  telephoneSHandle trainSHandle carWHandle  cowWHandle  dogWHandle sheepWHandle  telephoneWHandle trainWHandle];
     
% ************************************************************
% Randomised Stim numbers for Block Generated here
% ************************************************************
% % ************* Generate fresh Random Number ******************
seed = ClockRandSeed; % SET the random seed from the time-of-day clock.

pairs = 4;          % how many pair blocks to run        
StimlistRep = [];   % dummy/empty array
congList = [ 1 1 2 2 3 3 4 4 5 5 6 6 ; 1 7 2 8 3 9 4 10 5 11 6 12]; % congruent order

for instance = 1 : pairs    % for number of pair Blocks required
    attemptAgain = 1;
    attempts = 0;
    
    while attemptAgain      % Genereate the incongruent elements for this Block
        attemptAgain = 0;
        attempts = attempts + 1;
        trialIncongruent = zeros(12,2); 
        row  = 1;
        Omit = 0;
        Q = [0 0];
        pickList = [1 2 3 4 5 6 7 8 9 10 11 12];
        for n = 1:6
                pickList = pickList(pickList ~= n);         % eliminate first congruent Audio indexes from pickList
                pickList = pickList(pickList ~= (n + 6));   % eliminate second congruent Audio indexes from pickList
                if length(pickList) < 2     % Catches the error condition where not enough choices exist for inconguency
                    attemptAgain = 1;
                    break
                end

                Q = randsample(pickList,2);  % select two from the remaining incongruent list

                Omit = [Omit Q(1) Q(2)];     % Modify the pickList removing the latest selections from future picks
                pickList = [1 2 3 4 5 6 7 8 9 10 11 12];    
                for a = 1:length(Omit)
                    pickList = pickList(pickList ~= Omit(a));
                end

                trialIncongruent(row,1)= n;   trialIncongruent(row,2)= Q(1);  % report the values for the current index
                trialIncongruent(row+1,1)= n; trialIncongruent(row+1,2)= Q(2);
                Q = [0 0];
                row = row + 2;
        end
    end
    
    % Develop the stimuli sequence
    inCongList = trialIncongruent';                     % transpose the incong list
    Sublist = cat(2,inCongList,congList);               % resolve the cong/incong pair
    Sublist = Sublist(:,randperm(size(Sublist,2)));     % randomise this pair
    Sublist = Sublist(:,randperm(size(Sublist,2)));     % do it again !
    StimlistRep = [ StimlistRep Sublist ];              % append it to the generated list
end

StimlistRep; 
stimI = StimlistRep(1,:)
stimS = StimlistRep(2,:)

% set BACKGROUND to grey
BACKCOLOR=[153 153 153];
 
% *********************************************************************
% Run the Trials
% *********************************************************************
trialN = length(stimI); % number of trials for the entire experiment.
for trial = 1 : trialN
    % display FIXATION 
    textSize = 100;
    Screen('FillRect', EXPWIN, BACKCOLOR);
    Screen('TextSize', EXPWIN , textSize);
    Screen('DrawText', EXPWIN, '+', 365 , 225);   
    Screen(EXPWIN,'Flip');
 
    % Play the trial audio and wait for SOUND to finish
    
    trialAudio = Audio(stimS(trial));
%     audio_play = audio(trial);
    audio_tag_start = PsychPortAudio('Start', trialAudio, 1, 0, 1);
    [audio_tag_start audio_tag_stop q estStop] = PsychPortAudio('Stop', trialAudio,1 , 1);
    
    % Remove the FIXATION
    EraseScreen(BACKCOLOR);
    WaitSecs(1);
    
    %display trial IMAGE
    w = stimI(trial);
   
    trialImage = StimPic(w);
    Screen('DrawTexture',EXPWIN,trialImage);
    Screen('DrawingFinished',EXPWIN);
    image_on = Screen(EXPWIN,'Flip');
      
    % Collect a response
    % *********************************************************************
    responseWait = image_on + 2;
    noresp = 1;
    %audio_bleep = 0; % dont play blip
    bp = 0;
    
    while GetSecs() < responseWait
        if Gamepad('GetButton',1,8) && ~Gamepad('GetButton',1,7)
            RT = GetSecs() - image_on;
            bp = 1;
            noresp = 0;
            response = 'C';   %'%write to condfile CONGRUENT
            break
        elseif Gamepad('GetButton',1,7) && ~Gamepad('GetButton',1,8)
%             audio_buzz= 2; % play blip
            RT = GetSecs() - image_on;
            bp = 2;
            audio_buzz = 2;
            noresp = 0;
            response = 'I';   %'%write to condfile INCONGRUENT
            break
        elseif Gamepad('GetButton',1,8) && Gamepad('GetButton',1,7)
            RT = GetSecs() - image_on;
            noresp = 0;
            response = 'X';   %write that an ambiguous press occured
            break
        end
    end
        
    if noresp
        RT = GetSecs() - image_on;
        response = 'N';   %'%write to condfile No Answer
    end 
    
     %if (stimI(trial) == stimS(trial)) || (stimI(trial) == stimS(trial)+6)
     if (stimS(trial) == stimI(trial)) || (stimS(trial) == stimI(trial) + 6)    
         Cong = 1;
     else
         Cong = 2;
     end
     
     if (Cong == 1 &&  bp == 1)  || (Cong == 2 && bp == 2)
         PsychPortAudio('Start', bleep, 1, 0, 1);
         PsychPortAudio('Stop', bleep,1 , 1);
         audio_FB = 'bleep';
     elseif (Cong == 1 && bp == 2) || (Cong == 2 &&  bp == 1)  
         PsychPortAudio('Start', buzz, 1, 0, 1);
         PsychPortAudio('Stop', buzz,1 , 1);
         audio_FB = 'buzz';
     else
         audio_FB = 'none';
     end


    % *********************************************************************    
 
    EraseScreen(BACKCOLOR); % Remove the Image
    
    % Report the trial result
    fprintf(condFile,'%i %i, %i %s %s %s \n', trial, stimS(trial), stimI(trial), response, num2str(RT), audio_FB);
    fprintf('%i %i, %i %s %s %s \n', trial, stimS(trial), stimI(trial), response, num2str(RT), audio_FB);

end

 
    WaitSecs(1);
    
    % *********************************************************************
    % Close it all down
    % *********************************************************************  
    
    fclose(condFile);
    
    for stimList = 1 : length(StimPic)
        Screen('Close', StimPic(stimList));
    end
    for stimList = 1 : length(Audio)
        PsychPortAudio('Close', Audio(stimList)); 
    end
    
    sca;